import { ViewContainerRef, ComponentFactoryResolver, Type } from '@angular/core';
import { DialogComponent } from './dialog.component';
import { DialogOptions } from './dialog.service';
import { Observable } from 'rxjs';
export declare class DialogHolderComponent {
    private resolver;
    /**
     * Target element to insert dialogs
     */
    element: ViewContainerRef;
    /**
     * Array of dialogs
     */
    dialogs: Array<DialogComponent<any, any>>;
    /**
     * Constructor
     * @param resolver ComponentFactoryResolver
     */
    constructor(resolver: ComponentFactoryResolver);
    /**
     * Adds dialog
     * @param component Type<DialogComponent>
     * @param data object?
     * @param options DialogOptions?
     * @return Observable<*>
     */
    addDialog<T, T1>(component: Type<DialogComponent<T, T1>>, data?: T, options?: DialogOptions): Observable<T1>;
    /**
     * Removes dialog
     * @param component DialogComponent
     */
    removeDialog(component: DialogComponent<any, any>): void;
    private _removeElement;
    clear(): void;
}
